/*
 * WS281X.H
 *
 *  Created on: 2024625
 *      Author: Tyt85
 */

#ifndef SRC_WS281X_SPI_WS281X_H_
#define SRC_WS281X_SPI_WS281X_H_

#define PIXEL_NUM           180
#define END_LED_NUM         (PIXEL_NUM-1)
#define PIXEL_COLUMN        30
#define PIXEL_ROW           6
#define BRIGHTNESS_MAX      32              //ȫӣµ

typedef struct {
    uint32_t g;
    uint32_t r;
    uint32_t b;
}ws2812_in_spi_buffer_t;                //SPI 

typedef struct{
    uint8_t r ;
    uint8_t g ;
    uint8_t b ;
}ws2812_rgb_buffer_t ;

void WS2812x_Power_Set(FunctionalState s);

void WX281X_Init(void);

void WS281X_Update(void);

void WS281x_SingleLED_Color(ws2812_in_spi_buffer_t *buf,uint8_t red,uint8_t g,uint8_t b);

void WS281x_SetXYPixelColor(uint8_t x,uint8_t y,uint8_t red, uint8_t green, uint8_t blue);

void ARGB_ScreenScanning(uint8_t *pSta,uint8_t *pAddend,uint8_t red, uint8_t green, uint8_t blue);

void ARGB_FillRGB(uint8_t red, uint8_t green, uint8_t blue);

void PlayFunction_4(uint8_t red, uint8_t green, uint8_t blue);

void WS281x_LEDtest(void);

//void CharRightToLeft(uint8_t *pSta,uint8_t red, uint8_t green, uint8_t blue);

//void ARGB_FillLogoPIC_1(void);

void PlayFunction_1(void);

void PlayFunction_3(uint8_t *pSta,uint8_t red, uint8_t green, uint8_t blue);

static void color_hsv2rgb(uint32_t h, uint32_t s, uint32_t v, uint8_t *r, uint8_t *g, uint8_t *b);

extern ws2812_in_spi_buffer_t ws2812_buf[PIXEL_NUM];

extern uint8_t Function_state_1 ;
extern uint8_t Function_state_3 ;
extern uint8_t Function_state_4 ;

#endif /* SRC_WS281X_SPI_WS281X_H_ */
