/*
 * WS281X.C
 * Created on: 2024625
 * Author: Tyt85
   *  ӲSPI+DMA WS2812 
 *  SPI ƵΪ60M/15ֽڷʱΪ8*0.25us,һֽڶӦWS2812 2bitλ
   *      һWS2812 24λݺʱ24us256ŵҪ6.144msдݿܻᵼһ֡ݴ

   *      ʹӲ SPI  WS2812 ķʽĵƹȶɿʹ SPI  WS2812 ķʽĵƹⲻȶ
 *  I/O ֮䣬ʹⲿһ 3.3V ת 5V ĵ·ݴȶʱֲģڲӵ£ְǰŵ
   *     ھȲε£ӦŶ˼ṩȲα迹ƥĵ裬Ȳʱܵµһŵ𻵡
 */
#include "CH58x_common.h"
#include "WS281X.H"
#include "16x16.h"

volatile uint8_t Gbl_Brightness = 32;
__attribute__((aligned(4))) ws2812_in_spi_buffer_t ws2812_buf[PIXEL_NUM];
uint32_t map_table[8] = {0x8e888888,0xe8888888,
                         0x888e8888,0x88e88888,
                         0x88888e88,0x8888e888,
                         0x8888888e,0x888888e8,};


void WS2812x_Power_Set(FunctionalState s)
{

    if (s)
    {
        /*˷Դ*/
        GPIOB_ModeCfg(GPIO_Pin_4,GPIO_ModeOut_PP_5mA);
        GPIOB_ResetBits(GPIO_Pin_4);

        GPIOA_ModeCfg(GPIO_Pin_4,GPIO_ModeIN_Floating);
        GPIOA_ModeCfg(GPIO_Pin_5,GPIO_ModeIN_Floating);

        /*ѹԴ*/
        GPIOB_ModeCfg(GPIO_Pin_1,GPIO_ModeOut_PP_5mA);
        GPIOB_SetBits(GPIO_Pin_1);
        DelayMs(20);

        GPIOB_ModeCfg( GPIO_Pin_2, GPIO_ModeIN_PU );
        GPIOB_ModeCfg( GPIO_Pin_3, GPIO_ModeIN_PU );        /**/


    }
    else
    {
        /*˷Դ*/
        GPIOB_SetBits(GPIO_Pin_4);
        /*ѹԴ*/
        GPIOB_ResetBits(GPIO_Pin_1);
    }

}

void WX281X_Init(void)
{
    GPIOA_ModeCfg(GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15, GPIO_ModeOut_PP_20mA);
    SPI0_MasterDefInit();
    SPI0_CLKCfg(15);

    /*0709 Ӹλźţƴĵһϵʱһµ*/
    SPI0_MasterSendByte(0x00);
    DelayUs(300);

    ARGB_FillRGB(0,0,0);// ʼе
}

void WS281X_Update(void)
{
    SPI0_MasterDMATrans((uint8_t *)ws2812_buf, 12*PIXEL_NUM);       //WS2812_buf 3ԪأÿԪΪ4ֽ

    /*0709 Ӹλźţƴĵһϵʱһµ*/
    SPI0_MasterSendByte(0x00);
    DelayUs(300);
}

void SetBrightness(uint8_t br)
{
    if(br <= BRIGHTNESS_MAX)
        Gbl_Brightness = br ;
}

void WS281x_SingleLED_Color(ws2812_in_spi_buffer_t *buf,uint8_t r,uint8_t g,uint8_t b){

    r = r*Gbl_Brightness/256;
    g = g*Gbl_Brightness/256;
    b = b*Gbl_Brightness/256;

    buf->r = 0x88888888;
    for(uint8_t i=0;i<8;i++)
    {
        if(r&0x1) {
            buf->r |= map_table[i];
        }
        r>>=1;
    }

    buf->g = 0x88888888;
    for(uint8_t i=0;i<8;i++)
    {
        if(g&0x1) {
            buf->g |= map_table[i];
        }
        g>>=1;
    }

    buf->b = 0x88888888;
    for(uint8_t i=0;i<8;i++)
    {
        if(b&0x1) {
            buf->b |= map_table[i];
        }
        b>>=1;
    }
}

void ARGB_FillRGB(uint8_t red, uint8_t green, uint8_t blue) {
    for(uint32_t i=0;i<PIXEL_NUM;i++) {
        WS281x_SingleLED_Color(&ws2812_buf[i],0,0,0);
    }
    WS281X_Update();
}

void WS281x_SetXYPixelColor(uint8_t x,uint8_t y,uint8_t red, uint8_t green, uint8_t blue)
{
    uint8_t n ;                 // n ڵƴλ
    if((x<PIXEL_COLUMN)&&(y<PIXEL_ROW))
    {
        if(x&0x01)
            n = (x*6)+y ;              // 
        else
            n = (x*6)+(6-y)-1;            // ż
        WS281x_SingleLED_Color(&ws2812_buf[n], red, green, blue);
    }

}

void WS281x_LEDtest(void)
{
    static uint8_t TestMeter = 0 ;
    static uint16_t LED_state = 0;
    if(++TestMeter > 100)
    {
        TestMeter = 0;
        switch(LED_state)
        {
            case 0:     for(uint16_t i=0;i<PIXEL_NUM;i++)
                        {
                            WS281x_SingleLED_Color(&ws2812_buf[i],0xff,0,0);
                        }
                        break ;
            case 2:     for(uint16_t i=0;i<PIXEL_NUM;i++)
                        {
                            WS281x_SingleLED_Color(&ws2812_buf[i],0,0xff,0);
                        }
                        break ;
            case 4:     for(uint16_t i=0;i<PIXEL_NUM;i++)
                        {
                            WS281x_SingleLED_Color(&ws2812_buf[i],0,0,0xff);
                        }
                        break ;
            default:     for(uint16_t i=0;i<PIXEL_NUM;i++)
                        {
                            WS281x_SingleLED_Color(&ws2812_buf[i],0,0,0);
                        }
                        break ;
        }
        if(++LED_state>5)LED_state = 0;
        WS281X_Update();
    }
}

void ARGB_ScreenScanning(uint8_t *pSta,uint8_t *pAddend,uint8_t red, uint8_t green, uint8_t blue)
{
    uint32_t date ;
    uint16_t i = 0;

    for(uint8_t column = 0;column <PIXEL_COLUMN;column++)
    {
        date = *(pSta+column);
        if((pSta+column)>pAddend)
           date = 0;
        for(uint8_t row = 0;row <PIXEL_ROW;row++)
        {
            if(column&0x01)
            {
                if(date & 0x00000004)
                {
                    WS281x_SingleLED_Color(&ws2812_buf[i], red, green, blue);
                }
                else
                    WS281x_SingleLED_Color(&ws2812_buf[i], 0, 0, 0);
                date >>= 1 ;
            }
            else
            {
                if(date & 0x00000080)
                {
                    WS281x_SingleLED_Color(&ws2812_buf[i], red, green, blue);
                }
                else
                    WS281x_SingleLED_Color(&ws2812_buf[i], 0, 0, 0);
                date <<= 1 ;
            }
            i++;
        }
    }
}

void Numscan(uint8_t col,uint8_t width,uint8_t *pSta,uint8_t red, uint8_t green, uint8_t blue)
{
    uint8_t i ,j;uint8_t date ;
    i = col*6 ;j = 0 ;
    for(uint8_t column = col;column <(col+width);column++)
    {
       date = *(pSta+j);
       for(uint8_t row = 0;row <PIXEL_ROW;row++)
       {
           if(column&0x01)
           {
               if(date & 0x00000004)
               {
                   WS281x_SingleLED_Color(&ws2812_buf[i], red, green, blue);
               }
               else
                   WS281x_SingleLED_Color(&ws2812_buf[i], 0, 0, 0);
               date >>= 1 ;
           }
           else
           {
               if(date & 0x00000080)
               {
                   WS281x_SingleLED_Color(&ws2812_buf[i], red, green, blue);
               }
               else
                   WS281x_SingleLED_Color(&ws2812_buf[i], 0, 0, 0);
               date <<= 1 ;
           }
           i++;
       }
       j++;
    }
}
uint8_t Function_state_4 ;
extern volatile uint8_t Half_Second_Flag ;
void PlayFunction_4(uint8_t red, uint8_t green, uint8_t blue)
{
    static uint8_t Flashtime = 0;
    uint16_t py; uint16_t pmon; uint16_t pd; uint16_t ph; uint16_t pm; uint16_t ps;

    RTC_GetTime(&py,&pmon,&pd,&ph,&pm,&ps);

    if(!Function_state_4)
    {
        Function_state_4 = 1 ;
        SetBrightness(BRIGHTNESS_MAX);
        ARGB_FillRGB(0,0,0);
    }
    else
    {
        if(++Flashtime > 25)
        {
            Flashtime = 0 ;

            Numscan(4,4,(uint8_t *)&NumChar[ph/10], red, green, blue);
            Numscan(9,4,(uint8_t *)&NumChar[ph%10], red, green, blue);

            Numscan(16,4,(uint8_t *)&NumChar[pm/10], red, green, blue);
            Numscan(21,4,(uint8_t *)&NumChar[pm%10], red, green, blue);

            if(Half_Second_Flag)
            {
                WS281x_SingleLED_Color(&ws2812_buf[86], red, green, blue);
                WS281x_SingleLED_Color(&ws2812_buf[88], red, green, blue);
            }
            else
            {
                WS281x_SingleLED_Color(&ws2812_buf[86], 0, 0, 0);
                WS281x_SingleLED_Color(&ws2812_buf[88], 0, 0, 0);
            }
            WS281X_Update();
        }
    }
}
uint8_t DisplayBuffer[30]={0};
uint8_t Function_state_3 ;
#define CHAR_FLOW_SPEED 10
void PlayFunction_3(uint8_t *pSta,uint8_t red, uint8_t green, uint8_t blue)
{
    static uint8_t Flashtime = 0;
    static uint8_t CurrentChar = 0 ;
    static uint8_t index = 0 ;
    static uint32_t h = 0 ;
    static uint32_t s = 100 ;
    static uint32_t v = 100 ;

    uint16_t NN ;

    if(!Function_state_3)
    {
        for(uint8_t k;k<30;k++)
            DisplayBuffer[k] = 0;
        Flashtime = 0;
        CurrentChar = 0 ;
        index = 0 ;
        h = 180 ;
        s = 100 ;
        v = 100 ;
        SetBrightness(BRIGHTNESS_MAX);
        ARGB_FillRGB(0,0,0);
        Function_state_3++;
    }
    else
    {
        if(++Flashtime > CHAR_FLOW_SPEED)
        {
            Flashtime = 0 ;
            for(uint8_t i = 0;i<29;i=i+1)
            {
                DisplayBuffer[i]=DisplayBuffer[i+1];
            }

            if(*(pSta+CurrentChar) == '\0')
            {
                DisplayBuffer[29] = 0;
                index++;
                if(index > 30)
                {
                    index = 0 ;
                    CurrentChar = 0;
                }
            }
            else
            {
                NN = *(pSta+CurrentChar);
                NN = NN-32;         // space ASCIIֵΪ 32

                DisplayBuffer[29] = Char16x16[NN][index];
                if(index >= 5)
                {
                    CurrentChar++;
                    index = 0 ;
                }
                else
                    index++ ;
            }

            color_hsv2rgb(h,s,v,&red,&green,&blue);     /*ʺ罥*/
            if(++h == 360)
                h = 0;

            ARGB_ScreenScanning(&DisplayBuffer[0],&DisplayBuffer[30],red,green,blue);
            WS281X_Update();

        }
    }
}

ws2812_rgb_buffer_t ws2812_rgb_buffer[30][6];
void ARGB_FillLogoPIC_1(void)
{
    uint16_t index = 0;

    for(uint8_t i = 0;i<PIXEL_COLUMN;i=i+1)
    {
        if(i&0x01)
        {
            uint16_t temp ;
            temp = index+5 ;
            for(uint8_t j = 0;j < PIXEL_ROW;j++)
            {
                ws2812_rgb_buffer[i][j].r = LogoPIC[index][0] ;
                ws2812_rgb_buffer[i][j].g = LogoPIC[index][1] ;
                ws2812_rgb_buffer[i][j].b = LogoPIC[index][2] ;

                WS281x_SingleLED_Color(&ws2812_buf[temp], ws2812_rgb_buffer[i][j].r, ws2812_rgb_buffer[i][j].g, ws2812_rgb_buffer[i][j].b);
                index++;
                temp--;
            }
        }
        else
        {
            for(uint8_t j = 0;j < PIXEL_ROW;j++)
            {
                ws2812_rgb_buffer[i][j].r = LogoPIC[index][0] ;
                ws2812_rgb_buffer[i][j].g = LogoPIC[index][1] ;
                ws2812_rgb_buffer[i][j].b = LogoPIC[index][2] ;

                WS281x_SingleLED_Color(&ws2812_buf[index], ws2812_rgb_buffer[i][j].r, ws2812_rgb_buffer[i][j].g, ws2812_rgb_buffer[i][j].b);
                index++;
            }
        }
    }
    WS281X_Update();
}

uint8_t Function_state_1 ;
void PlayFunction_1(void)
{
    static uint8_t Flashtime = 0;
    static uint8_t bright ;
    if(!Function_state_1)
    {
        Flashtime = 0;
        bright = BRIGHTNESS_MAX ;
        Function_state_1++;
        ARGB_FillRGB(0,0,0);
    }
    else
    {
        if(++Flashtime > 20)
        {
            Flashtime = 0 ;
            switch(Function_state_1)
            {
                case 1 :
                    SetBrightness(BRIGHTNESS_MAX);Function_state_1++;
                break ;

                case 2 :
                    SetBrightness(0);Function_state_1++;
                break ;

                case 3 :
                    SetBrightness(BRIGHTNESS_MAX);Function_state_1++;
                break ;

                case 4 :
                    SetBrightness(0);Function_state_1++;
                break ;

                case 5 :
                    SetBrightness(BRIGHTNESS_MAX);Function_state_1++;
                break ;

                case 6 :
                    SetBrightness(bright);bright--;Flashtime = 15;if(0 == bright)Function_state_1++;
                break ;

                case 7 :
                    SetBrightness(bright);bright++;Flashtime = 15;if(BRIGHTNESS_MAX == bright)Function_state_1++;
                break ;

                case 8 :
                    SetBrightness(bright);bright--;Flashtime = 15;if(0 == bright)Function_state_1++;
                break ;

                case 9 :
                    SetBrightness(bright);bright++;Flashtime = 15;if(BRIGHTNESS_MAX == bright)Function_state_1 = 0;
                break ;
            }
            ARGB_FillLogoPIC_1();
        }
    }
}
/*
 * HSVɫռתΪRGBɫռ
 * @param  h HSVɫռHɫ, Χ0~360
 * @param  s HSVɫռSͶ, Χ0~100
 * @param  v HSVɫռV, Χ0~100
 * @param  r תRGB-Rֵָ
 * @param  g תRGB-Gֵָ
 * @param  b תRGB-Bֵָ
   * ÷color_hsv2rgb(H, S, V, &R, &G, &B)
 */
#if 1
 static void color_hsv2rgb(uint32_t h, uint32_t s, uint32_t v, uint8_t *r, uint8_t *g, uint8_t *b)
{
    h %= 360; // h -> [0,360]
    uint32_t rgb_max = v * 2.55f;
    uint32_t rgb_min = rgb_max * (100 - s) / 100.0f;

    uint32_t i = h / 60;
    uint32_t diff = h % 60;

    uint32_t rgb_adj = (rgb_max - rgb_min) * diff / 60;

    switch (i)
    {
    case 0:
        *r = rgb_max;
        *g = rgb_min + rgb_adj;
        *b = rgb_min;
        break;
    case 1:
        *r = rgb_max - rgb_adj;
        *g = rgb_max;
        *b = rgb_min;
        break;
    case 2:
        *r = rgb_min;
        *g = rgb_max;
        *b = rgb_min + rgb_adj;
        break;
    case 3:
        *r = rgb_min;
        *g = rgb_max - rgb_adj;
        *b = rgb_max;
        break;
    case 4:
        *r = rgb_min + rgb_adj;
        *g = rgb_min;
        *b = rgb_max;
        break;
    default:
        *r = rgb_max;
        *g = rgb_min;
        *b = rgb_max - rgb_adj;
        break;
    }
}
#endif






